//---------------------------------------------------------------------------
// N.V.Shokhirev http://www.shokhirev.com/nikolai.html
// Practical Numerical Methods Examples
// created: 20040726
// modified: 20051126
//---------------------------------------------------------------------------
unit fMachEpsW;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    RadioGroup1: TRadioGroup;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
  eps3: extended;
  eps2, sum2: double;
  eps1, sum1: single;
begin
  Memo1.Clear;
  case RadioGroup1.ItemIndex of
  0:begin
      eps1 := 1.0;
      repeat
        Memo1.Lines.Append(FloatToStr(eps1));
        eps1 := eps1/2.0;
        sum1 := 1.0 + eps1;
      until sum1 <= 1.0 ;
    end;
  1:begin
      eps2 := 1.0;
      repeat
        Memo1.Lines.Append(FloatToStr(eps2));
        eps2 := eps2/2.0;
        sum2 := 1.0 + eps2;
      until sum2 <= 1.0 ;
    end;
  2:begin
      eps3 := 1.0;
      while (eps3+1.0) > 1.0 do
      begin
        Memo1.Lines.Append(FloatToStr(eps3));
        eps3 := eps3/2.0;
      end;
    end;
  end;
end;

end.
