//---------------------------------------------------------------------------
// N.V.Shokhirev http://www.shokhirev.com/nikolai.html
// Practical Numerical Methods Examples
// created: 20040726
// modified: 20051126
//---------------------------------------------------------------------------
unit fRoundOff2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    EditN: TEdit;
    EditSum: TEdit;
    EditE: TEdit;
    EditX: TEdit;
    EditEps: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    EditSumI: TEdit;
    Label7: TLabel;
    EditEI: TEdit;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
  eps, x, n, sum1, sum, term: single;
begin
  x := StrToFloat(EditX.Text);
//  x   := -9.5;
  eps := StrToFloat(EditEps.Text);
  sum := 1.0;
  n   := 1.0;
  term := 1.0;
  repeat
    term := term*x/n;
    sum := sum + term;
    n := n + 1.0;
  until abs(term) < eps;
  EditN.Text := FloatToStr(n);
  EditSum.Text := FloatToStr(sum);
  EditE.Text := FloatToStr(exp(x));
  EditSumI.Text := FloatToStr(1.0/sum);
  EditEI.Text := FloatToStr(exp(-x));
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  eps, x, n, sum1, sum, term: double;
begin
  x := StrToFloat(EditX.Text);
  eps := StrToFloat(EditEps.Text);
  sum := 1.0;
  n   := 1.0;
  term := 1.0;
  repeat
    term := term*x/n;
    sum := sum + term;
    n := n + 1.0;
  until abs(term) < eps;
  EditN.Text := FloatToStr(n);
  EditSum.Text := FloatToStr(sum);
  EditE.Text := FloatToStr(exp(x));
  EditSumI.Text := FloatToStr(1.0/sum);
  EditEI.Text := FloatToStr(exp(-x));
end;

end.
